#include "mapeditor.h"
#include "qpen.h"

mapeditor::mapeditor(QWidget *parent) :
    QLabel(parent)
{

}


void mapeditor::paintEvent(QPaintEvent *)
{
    QPainter p(this);

    DrawGrid(&p);
    //p.drawRect(QRect(msX / bw * bw,msY / bh * bh,bw,bh));
    DrawCursor(&p);

    for(int i = 0; i < Tiles.count(); i++)
    {
        //p.drawPixmap(Tiles[i].x,Tiles[i].y,tileset->Tilesets);
        p.drawPixmap(Tiles[i].x,Tiles[i].y,tileset->Tilesets,Tiles[i].rect.x(),Tiles[i].rect.y(),Tiles[i].rect.width(),Tiles[i].rect.height());
    }

    this->update();

}


void mapeditor::mouseMoveEvent(QMouseEvent *ev)
{
    msX = ev->x();
    msY = ev->y();
}


//Create a dinamic grid
void mapeditor::DrawGrid(QPainter *p)
{
    QPen pen;
    pen.setColor(Qt::white);
    pen.setWidthF(1.5f);
    QVector<qreal> dash;
    dash << 1.0 << 5.0;
    pen.setDashPattern(dash);

    QPen old = p->pen();
    p->setPen(pen);

    for(int i = 0; i < this->width(); i+=32)
    {
        p->drawLine(i,0,i,this->height());
    }

    for(int i = 0; i < this->height(); i+=32)
    {
        p->drawLine(0,i,this->width(),i);
    }

    p->setPen(old);
}


void mapeditor::DrawCursor(QPainter *p)
{
     p->drawRect(QRect(msX / bw * bw,msY / bh * bh,bw,bh));
}


void mapeditor::mousePressEvent(QMouseEvent *ev)
{
    Tile t;

    t.ID = Tiles.count();
    t.x = ev->x() / bw * bw;
    t.y = ev->y() / bh * bh;
    t.rect = QRect(tileset->cropX,tileset->cropY,32,32);

    Tiles.append(t);

}
