#include "tileset.h"

Tileset::Tileset(QWidget *parent) :
    QLabel(parent)
{
}


void Tileset::paintEvent(QPaintEvent *)
{
     QPainter p(this);

     if(Tilesets.isNull())
     {

     }else
     {
         p.drawPixmap(0,0,Tilesets.width(),Tilesets.height(),Tilesets);
     }

     DrawGrid(&p);
     DrawCursor(&p);

     update();

}


void Tileset::mouseMoveEvent(QMouseEvent *ev)
{
    msx = ev->x();
    msy = ev->y();
}


void Tileset::mousePressEvent(QMouseEvent *ev)
{
    cropX = ev->x() / bw * bw;
    cropY = ev->y() / bh * bh;
}

void Tileset::DrawGrid(QPainter *p)
{
    QPen pen;
    pen.setColor(Qt::white);
    pen.setWidthF(1.5f);
    QVector<qreal> dash;
    dash << 1.0 << 5.0;
    pen.setDashPattern(dash);

    QPen old = p->pen();
    p->setPen(pen);

    for(int i = 0; i < this->width(); i+=32)
    {
        p->drawLine(i,0,i,this->height());
    }

    for(int i = 0; i < this->height(); i+=32)
    {
        p->drawLine(0,i,this->width(),i);
    }

    p->setPen(old);
}


void Tileset::LoadTileset(QString filename)
{
    Tilesets.load(filename);

    this->setMinimumHeight(Tilesets.height());
    this->setMinimumWidth(Tilesets.width());
    this->setMaximumWidth(Tilesets.width());
    this->setMaximumHeight(Tilesets.height());
}


void Tileset::DrawCursor(QPainter *p)
{
    p->drawRect(msx / bw * bw,msy/bh*bh,bw,bh);

}
